package org.jboss.security.auth;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import javax.security.auth.Subject;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.login.LoginContext;
import javax.security.auth.login.LoginException;
import org.jboss.security.auth.SystemAuthenticatorMBean;
import org.jboss.system.ServiceMBeanSupport;

public class SystemAuthenticator extends ServiceMBeanSupport implements SystemAuthenticatorMBean {
  private Subject systemSubject;
  
  private String securityDomain;
  
  private CallbackHandler callbackHandler;
  
  public String getSecurityDomain() {
    return this.securityDomain;
  }
  
  public void setSecurityDomain(String name) {
    this.securityDomain = name;
  }
  
  public Class getCallbackHandler() {
    Class clazz = null;
    if (this.callbackHandler != null)
      clazz = this.callbackHandler.getClass(); 
    return clazz;
  }
  
  public void setCallbackHandler(Class callbackHandlerClass) throws InstantiationException, IllegalAccessException {
    this.callbackHandler = callbackHandlerClass.newInstance();
  }
  
  protected void startService() throws Exception {
    try {
      LoginContext lc = new LoginContext(this.securityDomain, this.callbackHandler);
      lc.login();
      this.systemSubject = lc.getSubject();
    } catch (Throwable t) {
      this.log.fatal("SystemAuthenticator failed, server will shutdown NOW!", t);
      LoginException le = new LoginException("SystemAuthenticator failed, msg=" + t.getMessage());
      Object object = new Object(this, "SystemAuthenticatorExitThread");
      object.start();
    } 
  }
  
  protected void stopService() throws Exception {
    if (this.systemSubject != null) {
      LoginContext lc = new LoginContext(this.securityDomain, this.systemSubject, this.callbackHandler);
      lc.logout();
    } 
  }
}
